package org.processmining.framework.connections;

import java.util.Map;

import org.processmining.framework.connections.impl.AbstractStrongReferencingConnection;
import org.processmining.models.graphbased.directed.petrinet.PetrinetGraph;

public class ImportanceConnection extends AbstractStrongReferencingConnection {
	public final static String PETRINETGRAPH = "PetrinetGraph";
	public final static String ACTVITYIMPORTANCEMAPPING = "ActivityImportanceMapping";
	public final static String ATTRIBUTEIMPORTANCEMAPPING = "AttributeImportanceMapping";
	
	public ImportanceConnection(String label, PetrinetGraph net, Map<String, Float> activityImportanceMapping, Map<String, Float> attributeImportanceMapping) {
		super(label);
		put(PETRINETGRAPH, net);
		put(ACTVITYIMPORTANCEMAPPING, activityImportanceMapping);
		put(ATTRIBUTEIMPORTANCEMAPPING, attributeImportanceMapping);
	}
}