package org.processmining.plugins.complianceframework.GUI;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.List;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JCheckBox;
import javax.swing.JPanel;
import javax.swing.JScrollBar;
import javax.swing.JScrollPane;
import javax.swing.ScrollPaneConstants;

import org.processmining.framework.util.ui.widgets.ProMPropertiesPanel;
import org.processmining.framework.util.ui.widgets.WidgetColors;

import com.fluxicon.slickerbox.ui.SlickerScrollBarUI;

public class AttributeSelectionPanel extends ProMPropertiesPanel {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	
	private List<String> selectedAttributes;

	public AttributeSelectionPanel(String title, List<String> allAttributes, List<String> defaultAttributes) {
		super(title);
		this.setLayout(new BorderLayout());
		this.selectedAttributes = defaultAttributes;
		JPanel innerPanel = createCheckBoxPanel(allAttributes, defaultAttributes);
		JScrollPane scrollPane = createScrollPane(innerPanel);
		add(scrollPane);
	}

	private JScrollPane createScrollPane(JPanel panel) {

		final JScrollPane scrollPane = new JScrollPane(panel);
		// final JScrollPane scrollPane = new JScrollPane(component);
		scrollPane.setOpaque(false);
		scrollPane.setBackground(WidgetColors.PROPERTIES_BACKGROUND);
		scrollPane.getViewport().setOpaque(false);
		scrollPane.getViewport().setBackground(WidgetColors.PROPERTIES_BACKGROUND);
		scrollPane.setBorder(BorderFactory.createEmptyBorder());
		scrollPane.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_AS_NEEDED);
		scrollPane.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);
		JScrollBar vBar = scrollPane.getVerticalScrollBar();
		vBar.setUI(new SlickerScrollBarUI(vBar, new Color(0, 0, 0, 0), new Color(160, 160, 160),
				WidgetColors.COLOR_NON_FOCUS, 4, 12));
		vBar.setOpaque(false);
		vBar.setBackground(WidgetColors.PROPERTIES_BACKGROUND);
		vBar = scrollPane.getHorizontalScrollBar();
		vBar.setUI(new SlickerScrollBarUI(vBar, new Color(0, 0, 0, 0), new Color(160, 160, 160),
				WidgetColors.COLOR_NON_FOCUS, 4, 12));
		vBar.setOpaque(false);
		vBar.setBackground(WidgetColors.PROPERTIES_BACKGROUND);

		return scrollPane;
	}

	private JPanel createCheckBoxPanel(List<String> allAttributes, List<String> defaultAttributes) {
		JPanel result = new JPanel();
		BoxLayout layout = new BoxLayout(result, BoxLayout.Y_AXIS);
		result.setLayout(layout);

		for (String attribute : allAttributes) {
			JCheckBox cb = new JCheckBox(attribute);
			result.add(cb);
			cb.setSelected(defaultAttributes.contains(attribute));
			cb.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					JCheckBox sender = (JCheckBox)e.getSource();
					String checkBoxAttribute = sender.getText();
					if (sender.isSelected()){
						if (!AttributeSelectionPanel.this.selectedAttributes.contains(checkBoxAttribute))
							AttributeSelectionPanel.this.selectedAttributes.add(checkBoxAttribute);
					}
					else
					{
						if (AttributeSelectionPanel.this.selectedAttributes.contains(checkBoxAttribute))
							AttributeSelectionPanel.this.selectedAttributes.remove(checkBoxAttribute);
					}
					
				}
			});
		}

		return result;
	}
}
