package org.processmining.plugins.complianceframework.model;

import java.util.HashMap;
import java.util.Map.Entry;

public class DashboardExecutionStep extends HashMap<String,Object>
{
	private String activity;
	private boolean invisible=false;
	private static float epsilon=0.00005F;

	public DashboardExecutionStep(String activity)
	{
		this.activity=activity;
	}
	
	@Override
	public int hashCode()
	{
		return activity.hashCode();
	}


	public String getActivity() {
		return activity;
	}

	public String toString()
	{
		if (activity!=null)
			return activity+" "+super.toString();
		else
			return "BOTTOM-STEP";
	}
	
	public boolean equals(Object o)
	{
		if (o instanceof DashboardExecutionStep) {
			if (activity==null)
			{
				return (((DashboardExecutionStep)o).activity==null);
			}
			else {
				DashboardExecutionStep other = (DashboardExecutionStep)o;
				if (activity.equals(other.activity)) {
					if (other.keySet().size()!=keySet().size())
						return false;
					for(Entry<String, Object> entry : this.entrySet()) {
						Object otherValue = other.get(entry.getKey());
						Object thisValue = entry.getValue();
						if (otherValue == null)
							return false;
						else
							if (thisValue instanceof Number || otherValue instanceof Number) {
								double thisNumber;
								if (thisValue instanceof Number)
									thisNumber =((Number)thisValue).doubleValue();
								else if (thisValue instanceof String)
									try {
										thisNumber = Double.parseDouble((String) thisValue);
									} catch (NumberFormatException e) {
										return false;
									}
								else
									return false;
								double otherNumber;
								if (otherValue instanceof Number)
									otherNumber =((Number)otherValue).doubleValue();
								else if (otherValue instanceof String) {
									try {
										otherNumber = Double.parseDouble((String) otherValue);
									} catch (NumberFormatException e) {
										return false;
									}
								} else
									return false;
								if(thisNumber < otherNumber*(1-epsilon) || thisNumber > otherNumber * (1+epsilon))
									return false;
							}
							else
							{
								if (!otherValue.equals(entry.getValue()))
									return false;
							}
					}
					return true;
				}
				else
					return false;
			}
		}
		else
			return false;
	}

	public void setInvisible(boolean invisible) {
		this.invisible=invisible;
		
	}

	public boolean isInvisible() {
		return invisible;
	}

	public boolean equalVariableAssignment(DashboardExecutionStep step) {
		return super.equals(step);
	}
	
}

