/**
 * 
 */
package org.processmining.plugins.datacompliance.visualization;

import javax.swing.JComponent;

import org.deckfour.xes.model.XLog;
import org.processmining.contexts.uitopia.annotations.Visualizer;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.models.connections.petrinets.PNRepResultAllRequiredParamConnection;
import org.processmining.models.connections.petrinets.PNRepResultConnection;
import org.processmining.models.graphbased.directed.petrinet.PetrinetGraph;
import org.processmining.plugins.datacompliance.GUI.PNLogDataComplianceReplayResultVisPanel;
import org.processmining.plugins.petrinet.replayresult.PNRepResult;

/**
 * 
 * @author vgromov
 * @mail v.gromov@hotmail.com
 * @since June 4, 2014
 */
@Plugin(name = "Project Data Compliance to Log", returnLabels = { "Visualized Log-Model Alignment Projection to Log" }, returnTypes = { JComponent.class }, parameterLabels = { "Log-Model alignment" }, userAccessible = false)
@Visualizer
public class DataComplianceActivitiesResultVis {
	@PluginVariant(requiredParameterLabels = { 0 })
	public JComponent visualize(PluginContext context, PNRepResult logReplayResult) {
		System.gc();
		PetrinetGraph net = null;
		XLog log = null;
		try {
			PNRepResultAllRequiredParamConnection conn = context.getConnectionManager().getFirstConnection(PNRepResultAllRequiredParamConnection.class, context, logReplayResult);
			
			net = conn.getObjectWithRole(PNRepResultConnection.PN);
			log = conn.getObjectWithRole(PNRepResultConnection.LOG);
		} catch (Exception exc){
			context.log("No net can be found for this log replay result");
			return null;
		}
		
		return new PNLogDataComplianceReplayResultVisPanel(net, log, logReplayResult, context.getProgress());
	}
}
